 /* ht      .c   GG630504 */

 /* Adatok s fggvnyek a priht.c s gwht.c programokhoz.
    Lers az ibmcas.htm llomnyban. */

#include <fcntl.h>
#include <io.h>
#include <stat.h>
#include <stdio.h>

#ifndef inclPpaCasH
#include "ppacas.h"
#endif

SZ                 mpSzBht[] = { "Asm", "Basic", "Code", "Data" };

TOK                rgTok[] = {

 /*  ht   -> ht     -> gw0 + gw1  */

 /* 80 */ { "END",     0x81, 0x00 },
 /* 81 */ { "FOR",     0x82, 0x00 },
 /* 82 */ { "RESET",   0xFE, 0x8A },
 /* 83 */ { "SET",     0x00, 0x00 },
 /* 84 */ { "CLS",     0xC0, 0x00 },
 /* 85 */ { "CMD",     0x00, 0x00 },
 /* 86 */ { "RANDOM",  0xB9, 0x00 },
 /* 87 */ { "NEXT",    0x83, 0x00 },
 /* 88 */ { "DATA",    0x84, 0x00 },
 /* 89 */ { "INPUT",   0x85, 0x00 },
 /* 8A */ { "DIM",     0x86, 0x00 },
 /* 8B */ { "READ",    0x87, 0x00 },
 /* 8C */ { "LET",     0x88, 0x00 },
 /* 8D */ { "GOTO",    0x89, 0x00 },
 /* 8E */ { "RUN",     0x8A, 0x00 },
 /* 8F */ { "IF",      0x8B, 0x00 },
 /* 90 */ { "RESTORE", 0x8C, 0x00 },
 /* 91 */ { "GOSUB",   0x8D, 0x00 },
 /* 92 */ { "RETURN",  0x8E, 0x00 },
 /* 93 */ { "REM",     0x8F, 0x00 },
 /* 94 */ { "STOP",    0x90, 0x00 },
 /* 95 */ { "ELSE",    0xA1, 0x00 },
 /* 96 */ { "TRON",    0xA2, 0x00 },
 /* 97 */ { "TROFF",   0xA3, 0x00 },
 /* 98 */ { "DEFSTR",  0xAC, 0x00 },
 /* 99 */ { "DEFINT",  0xAD, 0x00 },
 /* 9A */ { "DEFSNG",  0xAE, 0x00 },
 /* 9B */ { "DEFDBL",  0xAF, 0x00 },
 /* 9C */ { "LINE",    0xB0, 0x00 },
 /* 9D */ { "EDIT",    0xA6, 0x00 },
 /* 9E */ { "ERROR",   0xA7, 0x00 },
 /* 9F */ { "RESUME",  0xA8, 0x00 },
 /* A0 */ { "OUT",     0x9C, 0x00 },
 /* A1 */ { "ON",      0x95, 0x00 },
 /* A2 */ { "OPEN",    0xBA, 0x00 },
 /* A3 */ { "FIELD",   0xFE, 0x82 },
 /* A4 */ { "GET",     0xFE, 0x98 },
 /* A5 */ { "PUT",     0xFE, 0x88 },
 /* A6 */ { "CLOSE",   0xBB, 0x00 },
 /* A7 */ { "LOAD",    0xBC, 0x00 },
 /* A8 */ { "MERGE",   0xBD, 0x00 },
 /* A9 */ { "NAME",    0xFE, 0x84 },
 /* AA */ { "KILL",    0xFE, 0x87 },
 /* AB */ { "LSET",    0xFE, 0x85 },
 /* AC */ { "RSET",    0xFE, 0x86 },
 /* AD */ { "SAVE",    0xBE, 0x00 },
 /* AE */ { "SYSTEM",  0xFE, 0x83 },
 /* AF */ { "LPRINT",  0x9D, 0x00 },
 /* B0 */ { "DEF",     0x97, 0x00 },
 /* B1 */ { "POKE",    0x98, 0x00 },
 /* B2 */ { "PRINT",   0x91, 0x00 },
 /* B3 */ { "CONT",    0x99, 0x00 },
 /* B4 */ { "LIST",    0x93, 0x00 },
 /* B5 */ { "LLIST",   0x9E, 0x00 },
 /* B6 */ { "DELETE",  0xA9, 0x00 },
 /* B7 */ { "AUTO",    0xAA, 0x00 },
 /* B8 */ { "CLEAR",   0x92, 0x00 },
 /* B9 */ { "CLOAD",   0x00, 0x00 },
 /* BA */ { "CSAVE",   0x00, 0x00 },
 /* BB */ { "NEW",     0x94, 0x00 },
 /* BC */ { "TAB(",    0xCE, 0x00 },
 /* BD */ { "TO",      0xCC, 0x00 },
 /* BE */ { "FN",      0xD1, 0x00 },
 /* BF */ { "USING",   0xD7, 0x00 },
 /* C0 */ { "VARPTR",  0xDA, 0x00 },
 /* C1 */ { "USR",     0xD0, 0x00 },
 /* C2 */ { "ERL",     0xD4, 0x00 },
 /* C3 */ { "ERR",     0xD5, 0x00 },
 /* C4 */ { "STRING$", 0xD6, 0x00 },
 /* C5 */ { "INSTR",   0xD8, 0x00 },
 /* C6 */ { "POINT",   0xDC, 0x00 },
 /* C7 */ { "TIME$",   0xFE, 0x8E },
 /* C8 */ { "MEM",     0x00, 0x00 },
 /* C9 */ { "INKEY$",  0xDE, 0x00 },
 /* CA */ { "THEN",    0xCD, 0x00 },
 /* CB */ { "NOT",     0xD3, 0x00 },
 /* CC */ { "STEP",    0xCF, 0x00 },
 /* CD */ { "+",       0xE9, 0x00 },
 /* CE */ { "-",       0xEA, 0x00 },
 /* CF */ { "*",       0xEB, 0x00 },
 /* D0 */ { "/",       0xEC, 0x00 },
 /* D1 */ { "^",       0xED, 0x00 },
 /* D2 */ { "AND",     0xEE, 0x00 },
 /* D3 */ { "OR",      0xEF, 0x00 },
 /* D4 */ { ">",       0xE6, 0x00 },
 /* D5 */ { "=",       0xE7, 0x00 },
 /* D6 */ { "<",       0xE8, 0x00 },
 /* D7 */ { "SGN",     0xFF, 0x84 },
 /* D8 */ { "INT",     0xFF, 0x85 },
 /* D9 */ { "ABS",     0xFF, 0x86 },
 /* DA */ { "FRE",     0xFF, 0x8F },
 /* DB */ { "INP",     0xFF, 0x90 },
 /* DC */ { "POS",     0xFF, 0x91 },
 /* DD */ { "SQR",     0xFF, 0x87 },
 /* DE */ { "RND",     0xFF, 0x88 },
 /* DF */ { "LOG",     0xFF, 0x8A },
 /* E0 */ { "EXP",     0xFF, 0x8B },
 /* E1 */ { "COS",     0xFF, 0x8C },
 /* E2 */ { "SIN",     0xFF, 0x89 },
 /* E3 */ { "TAN",     0xFF, 0x8D },
 /* E4 */ { "ATN",     0xFF, 0x8E },
 /* E5 */ { "PEEK",    0xFF, 0x97 },
 /* E6 */ { "CVI",     0xFD, 0x81 },
 /* E7 */ { "CVS",     0xFD, 0x82 },
 /* E8 */ { "CVD",     0xFD, 0x83 },
 /* E9 */ { "EOF",     0xFF, 0xA3 },
 /* EA */ { "LOC",     0xFF, 0xA4 },
 /* EB */ { "LOF",     0xFF, 0xA5 },
 /* EC */ { "MKI$",    0xFD, 0x84 },
 /* ED */ { "MKS$",    0xFD, 0x85 },
 /* EE */ { "MKD$",    0xFD, 0x86 },
 /* EF */ { "CINT",    0xFF, 0x9C },
 /* F0 */ { "CSNG",    0xFF, 0x9D },
 /* F1 */ { "CDBL",    0xFF, 0x9E },
 /* F2 */ { "FIX",     0xFF, 0x9F },
 /* F3 */ { "LEN",     0xFF, 0x92 },
 /* F4 */ { "STR$",    0xFF, 0x93 },
 /* F5 */ { "VAL",     0xFF, 0x94 },
 /* F6 */ { "ASC",     0xFF, 0x95 },
 /* F7 */ { "CHR$",    0xFF, 0x96 },
 /* F8 */ { "LEFT$",   0xFF, 0x81 },
 /* F9 */ { "RIGHT$",  0xFF, 0x82 },
 /* FA */ { "MID$",    0xFF, 0x83 },
 /* FB */ { "{FB}",    0x00, 0x00 },
 /* FC */ { "{FC}",    0x00, 0x00 },
 /* FD */ { "{FD}",    0x00, 0x00 },
 /* FE */ { "{FE}",    0x00, 0x00 },
 /* FF */ { "{FF}",    0x00, 0x00 } };

B                  bTmp;
B                  bHtType   = bHtData;
U                  ibCur     = 0;
U                  ibMac     = 0;
B                  rgb[ibMax];
U                  uTmp;

 /*------------------------------------------------------------------------*/

U                  URead( V )
 {
 B                 bLo;
 B                 bHi;
 bLo = BRead();
 bHi = BRead();
 return (bHi<<8)|bLo;
 }

 /*------------------------------------------------------------------------*/

R                  RLoadHtSz( sz_ )
 SZ                sz_;
 {
 L                 lTmp;
 W                 hf;

 if ( (hf = open( sz_, O_RDONLY | O_BINARY ))<0 )
 then {
      fprintf( stderr, "Nem tallom a %s llomnyt.\n", sz_ );
      return rError;
      }


 if ( (lTmp = filelength( hf )) < 0L )
 then {
      fprintf( stderr, "A %s llomnynak mg hossza sincs?\n", sz_ );
      close( hf );
      return rError;
      }

 if ( lTmp==0L )
 then {
      fprintf( stderr, "A %s llomny 0 byte hossz.\n", sz_ );
      return rError;
      }

 if ( lTmp>(L)ibMax )
 then {
      ibMac = ibMax;
      fprintf( stderr, "A %s llomny %ld byte hossz.\n",
                          sz_,        lTmp );

      fprintf( stderr, "A %u. byte utni rszt nem tltttem be.\n",
                          ibMac );
      }
 else ibMac = (U)lTmp;

 if ( read( hf, rgb, ibMac )<0 )
 then {
      fprintf( stderr, "Hiba a %s llomnybl val beolvass kzben.\n", sz_ );
      close( hf );
      return rError;
      }

 if ( close( hf )<0 )
 then {
      fprintf( stderr, "Hiba a %s llomny lezrsakor.\n", sz_ );
      close( hf );
      return rError;
      }

 fprintf( stderr, "A %s llomnybl %u byte-ot beolvastam.\n",
                     sz_,           ibMac );

 /* Tpus meghatrozsa. */

 bHtType = bHtData;

 if ( ibMac > 8 )
 then {
      ibCur = 0;
      bTmp = BRead();
      if ( bTmp == 0x55 )
      then bHtType = bHtCode;
      else if ( bTmp == 0xD3 )
           then {
                bTmp = BRead();
                if ( bTmp == 0xD3 )
                then bHtType = bHtBasic;
                else bHtType = bHtAsm;
                }
      }
 ibCur = 0;

 fprintf( stderr, "Tpus: " );
 PriHtTypePfile( stderr );
 fprintf( stderr, ".\n" );

 return rOk;
 }

 /*------------------------------------------------------------------------*/

V                  PriHtTypePfile( pfile_ )
 FILE *            pfile_;
 {
 fprintf( pfile_, "HT-1080Z-%s", mpSzBht[bHtType] );
 }

 /*^^^*/
